# merge the code that initially executes out of flash with the RAM image

($flashFile, $ramFile) = @ARGV;

open(FLASH, $flashFile) or die "$flashFile: $!\n";

while(<FLASH>) {
	print if /^S3/;
}

open(RAM, $ramFile) or die "$ramFile: $!\n";

while(<RAM>) {
	if(/^S3(..)(........)(.*)(\w\w)/) {
		$addr = sprintf('%08X', hex($2) - 0x00200000 + 0x200);
		$len = $1;
		$csum = hex($1);
		$content = $3;
		for (my $i=0; $i<length($addr); $i+=2) {
			my $byte = substr($addr,$i,2);
			$csum += hex($byte);
		}
		for (my $i=0; $i<length($content); $i+=2) {
			my $byte = substr($content,$i,2);
			$csum += hex($byte);
		}
		$csum &= 0xff;
		$csum = ~$csum;
		$csum &= 0xff;
		printf "S3${len}${addr}${content}%02X\n", ${csum};
	}
	print if /^S7/;
}
